//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  DarkGray
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_level1  0
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern string TimeFrame   = "Current time frame";
extern double Period1     =  12;
extern double Period2     =  12;
extern double Period3     =   5;
extern bool   Interpolate = true;

//
//
//
//
//

double tvi[];
double tvihuu[];
double tvihud[];
double tvihdd[];
double tvihdu[];
double slope[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(5);
   IndicatorBuffers(6);
   SetIndexBuffer(0,tvihuu); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,tvihud); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,tvihdd); SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(3,tvihdu); SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(4,tvi);
   SetIndexBuffer(5,slope);

      //
      //
      //
      //
      //
         
      timeFrame         = stringToTimeFrame(TimeFrame);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame=="returnBars";       if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);

      //
      //
      //
      //   
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+" Blau etgodick tick volume indicator ("+DoubleToStr(Period1,1)+","+DoubleToStr(Period2,1)+","+DoubleToStr(Period3,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { tvi[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for(int i = limit; i >= 0; i--)
      {
         double upTicks = (Volume[i]+(Close[i]-Open[i])/Point) / 2.0;
         double dnTicks = (Volume[i] - upTicks);
         double avgUp = iEma(iEma(upTicks,Period1,i,0),Period2,i,1);
         double avgDn = iEma(iEma(dnTicks,Period1,i,2),Period2,i,3);
            if (avgUp+avgDn != 0)
                  tvi[i] = iEma(100.0*(avgUp-avgDn)/(avgUp+avgDn),Period3,i,4);
            else  tvi[i] = iEma(0                                ,Period3,i,4);                  
            tvihuu[i] = EMPTY_VALUE;
            tvihud[i] = EMPTY_VALUE;
            tvihdd[i] = EMPTY_VALUE;
            tvihdu[i] = EMPTY_VALUE;

            //
            //
            //
            //
            //
                           
            slope[i] = slope[i+1];
               if (tvi[i] > tvi[i+1]) slope[i] =  1;
               if (tvi[i] < tvi[i+1]) slope[i] = -1;
               if (tvi[i]>0)
               if (slope[i]==1)
                     tvihuu[i] = tvi[i];
               else  tvihud[i] = tvi[i];
               if (tvi[i]<0)
               if (slope[i]==1)
                     tvihdu[i] = tvi[i];
               else  tvihdd[i] = tvi[i];
      }
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         tvi[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period1,Period2,Period3,4,y);
         tvihuu[i] = EMPTY_VALUE;
         tvihud[i] = EMPTY_VALUE;
         tvihdd[i] = EMPTY_VALUE;
         tvihdu[i] = EMPTY_VALUE;
         slope[i]  = slope[i+1];
               if (tvi[i] > tvi[i+1]) slope[i] =  1;
               if (tvi[i] < tvi[i+1]) slope[i] = -1;
               if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
               tvi[i+k]  = tvi[i]  + (tvi[i+n] - tvi[i] )*k/n;
   }
   for (i=limit; i>=0; i--)
   {
      if (tvi[i]>0)
         if (slope[i]==1)
               tvihuu[i] = tvi[i];
         else  tvihud[i] = tvi[i];
      if (tvi[i]<0)
         if (slope[i]==1)
               tvihdu[i] = tvi[i];
         else  tvihdd[i] = tvi[i];
   }
      
   //
   //
   //
   //
   //

   return(0);
         
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][5];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
} 

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}